<template>
<div class="wrapper wrapper-content animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="ibox float-e-margins">
        <div class="ibox-title">
            <h5>List Of Supplier</h5>
            <div class="ibox-tools">
                <a class="btn btn-primary btn-xs" @click="modal_show()">
                    Add Supplier
                </a>
                <a @click="load_supplier()">
                    <i class="fa fa-refresh"></i>
                </a>
          </div>
        </div>
        <!-- /.ibox-titel -->
        
        <div class="ibox-content">
            <!-- Search and filter form -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="pull-left form-inline">
                        <label>Show 
                            <input type="number" v-model="show_row" class="form-control input-sm" 
                                    style="width:60px;" min="1" max="1000">
                        </label>


                        <label>&nbsp;&nbsp;Limit
                            <input type="number" v-model="limit" class="form-control input-sm" 
                                    style="width:70px;" min="1" max="1000">
                        </label>
                    </div>

                    <div class="pull-right form-inline">
                        <label>Search:
                            <input v-model="search_key" class="form-control input-sm">
                        </label>&nbsp;
                    </div>
                </div>
            </div>
            <!-- /.row -->
          
            <div class="row" v-if="suppliers.total">
                <div class="col-lg-12">
                    <div>
                        <div>
                            <p class="pull-left" style="margin-top: 7px;">
                                Showing  {{ suppliers.from }} to  {{ suppliers.to }}  of  {{ suppliers.total }} entries.
                            </p>
                        </div>
                        <div class="table_pagination">
                            <div class="btn-group pull-right pagination pagination-sm no-margin" style="margin:-0px;">
                        
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !suppliers.prev_page_url }" 
                                    @click=" gen_uri( suppliers.prev_page_url )"
                                >
                                    <span>Prev</span>
                                </a>  
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !suppliers.first_page_url }" 
                                    @click=" gen_uri( suppliers.first_page_url )">
                                    <span>First</span>
                                </a>
                                <a class="btn btn-white btn-sm disabled"><span>...</span></a>
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !suppliers.last_page_url }" 
                                    @click=" gen_uri(suppliers.last_page_url)">
                                <span>Last</span>
                                </a>
                                <a class="btn btn-white btn-sm" 
                                    v-bind:class="{ disabled : !suppliers.next_page_url }" 
                                    @click=" gen_uri( suppliers.next_page_url )"
                                >
                                <span>Next</span>
                                </a>
                            </div>
                        </div>        
                    </div>
                </div>
            </div>
            <!-- /.row -->

            <!-- Table -->
            <div class="project-list table-responsive ">
                <table class="table table-stripped">
                    <thead>
                        <tr>
                            <th class="text-center">#</th>
                            <th>Code</th>
                            <th>Name</th>
                            <th>Contact</th>
                            <th>Bank</th>
                            <th>&nbsp;</th>
                        </tr>
                    </thead>
                    <tbody v-if="loading">
                        <tr>
                            <td colspan="7">
                                <spinner></spinner>
                            </td>
                        </tr>
                    </tbody>
                    <tbody  v-else-if="suppliers.data.length">
                        <supplier-table v-for="(supplier, row) in suppliers.data" 
                                    :key="supplier.id" 
                                    :supplier="supplier" 
                                    :row="row"
                                    v-on:edit="modal_show"
                                    v-on:delete="supplier_delete"
                        >
                        </supplier-table>
                    </tbody>    
                    <tbody v-else>
                        <tr>
                            <td colspan="7" class="text-center">
                                No Result!
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
            <!-- /.table-responsive -->
        </div>
        <!-- /.ibox-content -->
      </div>
      <!-- /.ibox float-e-margins -->
    </div>
    <!-- /.col-lg-12 -->
  </div>
  <!-- /.row -->

  <supplier-modal v-on:save="supplier_save" v-bind:modal="modal">
  </supplier-modal>
</div>  
<!-- /.wrapper wrapper-content animated fadeInRight -->
</template>

<script>
import axios from 'axios'
import Table from './Table.vue'
import Modal from './Modal.vue'
import Spinner from '../../other/Spinner.vue'
import appService from '../../../app.service.js'

export default {
    components: {
        'supplier-modal': Modal,
        'supplier-table': Table,
        'spinner': Spinner
    },
    data () {
        return {
            loading: false,
            search_key: '',
            show_row: 10,
            limit: 100,
            uri: '',
            suppliers: [],
            modal: { 
                pause_save: false,
                errors: '',
                data: {
                    code: '',
                    name: '',
                    address: '',
                    tel_no: '',
                    cel_no: '',
                    contact_person: '',
                    terms: '',
                    bank_account: '',
                    bank: '',
                    branch: '',
                    remarks: '',
                    id: ''
                }
            },
        }
    },
    methods: {
        load_supplier () {
            this.loading = true
            let uri = this.uri
            axios.get(uri).then((response,reject) => {
                this.suppliers = response.data.suppliers
                this.loading = false
            }).catch(response => {
                reject(response.status)
                this.loading = false
            })
        },
        gen_uri (qry_page = '') {
            let query = {
                base: 'supplier',
                page: qry_page.substr(1),
                show_row: this.show_row,
                limit: this.limit,
                search_key: this.search_key,
            }
            this.uri = appService.crud.generate_url( query ) 
            this.$router.push( this.uri )
        },
        modal_show( row_data ) {
            this.modal.errors = ''

            if(row_data) {
                this.modal.data = {
                    code: row_data.code,
                    name: row_data.name,
                    address: row_data.address,
                    tel_no: row_data.tel_no,
                    cel_no: row_data.cel_no,
                    contact_person: row_data.contact_person,
                    terms: row_data.terms,
                    bank_account: row_data.bank_account,
                    bank: row_data.bank,
                    branch: row_data.branch,
                    remarks: row_data.remarks,
                    id: row_data.id,
                }
            }else{
                this.modal.data = {
                    code: '',
                    name: '',
                    address: '',
                    tel_no: '',
                    cel_no: '',
                    contact_person: '',
                    terms: '',
                    bank_account: '',
                    bank: '',
                    branch: '',
                    remarks: '',
                    id: '',
                }
            }

            $('#supplier_modal').modal('show');
        },
        supplier_save( data ) {
            this.modal.pause_save = true
            if(!data.id) {
                this.supplier_store( data )
            }else{
                this.supplier_update( data )
            }
        },
        supplier_store( data ) {
            appService.crud.store( '/supplier', data ).then(response => {
                if(response.errors) {
                    this.modal.errors = response.errors
                }else{
                    $('#supplier_modal').modal('hide')
                    toastr.success( response.message, 'Saved!' )
                    this.load_supplier()
                }
                this.modal.pause_save = false
            })
        },
        supplier_update( data ){
            appService.crud.update( `/supplier/${data.id}`, data ).then(response => {
                if(response.errors) {
                    this.modal.errors = response.errors
                }else{
                    $('#supplier_modal').modal('hide')
                    toastr.success( response.message, 'Updated!' )
                    this.load_supplier()
                }
            })
            this.modal.pause_save = false
        },
        supplier_delete( id ){
            appService.crud.delete( `/supplier/${id}` ).then(response => {
                if(response.errors) {
                    toastr.error( response.message, 'Error!' )
                }else{
                    toastr.error( response.message, 'Deleted!' )
                    this.load_supplier()
                }
            })  
        },
    },  
    watch: {
        '$route' (to, from) {
            this.load_supplier()
        },
        show_row: function () {
            this.loading = true
            this.gen_uri()
        },
        limit: function () {
            this.loading = true
            this.gen_uri()
        },
        search_key: function () {
            this.loading = true
            setTimeout(() => {
                this.gen_uri()
            }, 1500)
        }
    },
    created () {
        this.gen_uri()
        this.load_supplier()
    }
}
</script>